<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 Mario Haim (mario@bramble-it.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'SQL Frontend' for the 'mh_omsqlio' extension.
 *
 * @author	Mario Haim <mario@bramble-it.com>
 */


require_once(PATH_tslib."class.tslib_pibase.php");

class tx_mhomsqlio_pi1 extends tslib_pibase {
	var $prefixId = "tx_mhomsqlio_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_mhomsqlio_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "mh_omsqlio";	// The extension key.
	
	var $aFlexform = array();
	var $oDb;
	var $oSelect;
	var $oCallback;
	var $aDb = array();
	var $aForeign = array();
	var $sTemplate = '';
	var $sDiv = 'tx_mhomsqlio_pi1-';
	var $sForm = 'tx_mhomsqlio_form-';
	var $sLinebreak;
	var $sContElem;
	var $nCntResult = 0;
	
	function main($content, $conf) {
		//basic init functions - positioned here since the CE is way more important
		if(!t3lib_extMgm::isLoaded('mh_lib')) die('Required extension <strong>mh_lib</strong> not loaded!');
		tx_mhlib::load('mh_xajax');
		$this->sContElem = $GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getCe($this);
		//standard definitions
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$GLOBALS['TSFE']->set_no_cache();
		$this->pi_USER_obj = 1;
		//set content element on important names
		$this->sDiv .= $this->sContElem;
		$this->sForm .= $this->sContElem;
		//initialize flexform
		$this->pi_initPIflexForm();
		$piFlexForm = $this->cObj->data['pi_flexform'];
		if(is_array($piFlexForm['data'])) foreach($piFlexForm['data'] as $sheet => $data) {
		    foreach($data as $lang => $value) {
				foreach($value as $key => $val) {
					$temp = explode('_', $key);
					if($temp[0] == 'mhomsqlio')
						$this->aFlexform[$temp[1]][implode('_', array_slice($temp, 2))] = $this->pi_getFFvalue($piFlexForm, $key, $sheet);
				}
			}
		}
		//basic test if special statement or db table is defined - prepare table name if needed
		if($this->aFlexform['d']['table'] == '' && $this->aFlexform['d']['special'] == '') 
			return '<strong>'.$this->extKey.'</strong>: '.$this->pi_getLL('error.settings');
		else if($this->aFlexform['d']['table']{0} != '`') $this->aFlexform['d']['table'] = '`'.$this->aFlexform['d']['table'].'`';
		//special flexform settings
		if($this->aFlexform['a']['changedel'] != '') {
			$temp = t3lib_div::trimExplode(';', $this->aFlexform['a']['changedel']);
			$this->aFlexform['a']['changedel'] = array(
				'col' => trim($temp[0]),
				'del' => trim($temp[2]),
				'undel' => trim($temp[1])
			);
		}
		if($this->aFlexform['a']['restrict'] != '') $this->aFlexform['a']['restrict'] = t3lib_div::trimExplode(',', $this->aFlexform['a']['restrict']);
		else $this->aFlexform['a']['restrict'] = false;
		$aTemp = $this->escapedTrimExplode(';', $this->aFlexform['a']['callback']);
		
		$this->aFlexform['a']['callback'] = array();
		if(count($aTemp) > 0) {
			for($i = 0; $i < count($aTemp); $i++) {
				list($sName, $sFunc, $sDir) = $this->escapedTrimExplode(':', $aTemp[$i], -1, true);
				if($sName != '' && $sFunc != '' && ($sDir == 'in' || $sDir == 'out')) $this->aFlexform['a']['callback'][$sName][$sDir] = $sFunc;
			}
		}
		//require needed files
		$sDirAdodb = t3lib_extMgm::extPath('adodb');
		if(!is_dir($sDirAdodb)) {
			return 'Required extension <strong>adodb</strong> not loaded!';
		} else include_once($sDirAdodb.'adodb/adodb.inc.php');
		tx_mhlib::load('mh_select');
		tx_mhlib::load('mh_dbal');
		tx_mhlib::load('mh_table');
		if(count($this->aFlexform['a']['callback']) > 0) {
			include_once(t3lib_extMgm::siteRelPath('mh_omsqlio').'pi1/class.tx_mhomsqlio_callback.php');
			$this->oCallback = new tx_mhomsqlio_callback($this);
		}
		
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->charSettings($this->prefixId, $this->aFlexform['g']['charset'], true);
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->setRequestURI($this->prefixId, $this->pi_getPageLink($GLOBALS['TSFE']->id));
		//register functions
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('Submit', &$this, '_submit'), array('callback' => 'mh_omsqlio_callback'));
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('ShowEdit', &$this, '_showEdit'), array('callback' => 'mh_omsqlio_callback'));
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('ShowAdd', &$this, '_showAdd'), array('callback' => 'mh_omsqlio_callback'));
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('Abort', &$this, '_abort'), array('callback' => 'mh_omsqlio_callback'));
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('Del', &$this, '_del'), array('callback' => 'mh_omsqlio_callback'));
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('MultipleDel', &$this, '_multipleDel'), array('callback' => 'mh_omsqlio_callback'));
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('MultipleEdit', &$this, '_multipleEdit'), array('callback' => 'mh_omsqlio_callback'));
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('Download', &$this, '_download'), array('callback' => 'mh_omsqlio_callback'));
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->register($this->prefixId, array('Filter', &$this, '_filter'), array('callback' => 'mh_omsqlio_callback'));
		//iinitiate class-wide stuff
		$this->oDb = t3lib_div::makeInstance('mh_dbal');
		$this->oDb->main($this->aFlexform['d']['t3'], $this->aFlexform['d']['type'], $this->aFlexform['d']['host'], $this->aFlexform['d']['username'], 
			$this->aFlexform['d']['password'], $this->aFlexform['d']['name']);
		$this->oSelect = new mh_select('');
		$this->oSelect->setPrepare($this->aFlexform['g']['charset'], $this->aFlexform['a']['nohtmlentities'], ENT_NOQUOTES, true);
		//set linebreak
		if(TYPO3_OS == 'WIN') $this->sLinebreak = chr(13).chr(10);
		else $this->sLinebreak = chr(10);
		//special links
		$aLink = $this->escapedTrimExplode(';', $this->aFlexform['a']['links'], -1, true);
		$this->aFlexform['a']['links'] = array();
		for($i = 0; $i < count($aLink); $i++) {
			list($sName, $sCaption, $sLink) = $this->escapedTrimExplode(':', $aLink[$i], 3);
			$this->aFlexform['a']['links'][trim($sName)] = array('caption' => trim($sCaption), 'link' => trim($sLink));
		}
		//conditional formatting
		if(trim($this->aFlexform['o']['condform']) != '') {
			$this->aFlexform['o']['condform'] = t3lib_div::trimExplode($this->sLinebreak, $this->aFlexform['o']['condform']);
			for($i = 0; $i < count($this->aFlexform['o']['condform']); $i++) 
				$this->aFlexform['o']['condform'][$i] = $this->escapedTrimExplode(':', $this->aFlexform['o']['condform'][$i], 2, true);
		} else $this->aFlexform['o']['condform'] = false;
		//show fields at certain positions
		$aPos = $this->escapedTrimExplode(',', $this->aFlexform['d']['fields'], -1, true);
		$this->aFlexform['d']['fields'] = array();
		for($i = 0; $i < count($aPos); $i++) $this->aFlexform['d']['fields'][(array_key_exists($aPos[$i], $this->aFlexform['a']['links']) ? 'l:' : 'c:').$aPos[$i]] = $i;
		//get column aliases (titles)
		$title = $this->escapedTrimExplode(',', $this->aFlexform['o']['titles']);
		//get column widths if wanted
		$this->aFlexform['o']['width'] = (($this->aFlexform['o']['width'] != '') ? t3lib_div::trimExplode(',', $this->aFlexform['o']['width']) : array());
		//add titles to special links
		if(count($this->aFlexform['a']['links']) > 0) foreach($this->aFlexform['a']['links'] as $sName => $aConf)
			$this->aFlexform['a']['links'][$sName]['title'] = $title[$this->aFlexform['d']['fields']['l:'.$sName]];
		//load template
		if($this->aFlexform['o']['template-fix'] !== '-') $sTmpl = 'uploads/tx_mhomsqlio/'.$this->aFlexform['o']['template-fix'];
		else $sTmpl = 'uploads/tx_mhomsqlio/'.$this->aFlexform['o']['template'];
		if(!is_file($sTmpl)) $this->sTemplate = $this->getContents(t3lib_extMgm::extPath($this->extKey).'res/tx_mhomsqlio_pi1.html');
		else $this->sTemplate = $this->getContents($sTmpl);
		unset($content);
		if($this->aFlexform['d']['special'] == '') {
			//get table structure
			if($oResult = $this->oDb->execute('DESCRIBE '.$this->aFlexform['d']['table'])) {
				//foreign keys
				$aForeignTemp = $this->escapedTrimExplode(';', $this->aFlexform['a']['foreign']);
				if(count($aForeignTemp) > 0) {
					foreach($aForeignTemp as $sForeign) {
						$aTemp = $this->escapedTrimExplode(',', $sForeign, 6);
						$this->aForeign[$aTemp[0]] = array(
							'fk' => $aTemp[0],
							'table' => $aTemp[1],
							'pk' => $aTemp[2],
							'show' => (isset($aTemp[3]) ? $aTemp[3] : $aTemp[2]),
							'order' => (isset($aTemp[4]) ? (' ORDER BY '.$aTemp[4]) : ''),
							'where' => (isset($aTemp[5]) ? (' '.$aTemp[5]) : '')
						);
					}
				}
				//fetch database table structure
				$i = $j = 0;
				while($row = $this->oDb->get($oResult)) {
					//find length
					if(strpos($row['Type'], '(') > 0) {
						list($type, $temp) = explode('(', $row['Type']);
						list($length) = explode(')', $temp);
					} else {
						list($type) = explode(' ', $row['Type']);
						$length = -1;
					}
					//convert tinyint smaller equal 3 to bool if wanted
					if($this->aFlexform['a']['tiny'] == 0) if(strtolower($type) == 'tinyint' && $length <= 3) $type = 'bool';
					//replace foreign keys if wanted
					if(array_key_exists($row['Field'], $this->aForeign)) {
						$type = 'foreign';
						$length = $row['Field'];
					}
					$this->aDb[$i] = array(
						'name' => $row['Field'],
						'type' => $type,
						'length' => $length,
						'pk' => (($row['Key'] == 'PRI') ? 1 : 0),
						'show' => ((array_key_exists('c:'.$row['Field'], $this->aFlexform['d']['fields']) || count($this->aFlexform['d']['fields']) == 0) ? 1 : 0),
						'datesel' => ((strpos($this->aFlexform['a']['date'], $row['Field']) !== false) ? 1 : 0),
						'tstamp' => ((strpos($this->aFlexform['a']['tstamp'], $row['Field']) !== false) ? 1 : 0),
						'rte' => ((strpos($this->aFlexform['a']['rte'], $row['Field']) !== false) ? 1 : 0),
					);
					//title
					$this->aDb[$i]['title'] = (($title[$this->aFlexform['d']['fields']['c:'.$this->aDb[$i]['name']]] != '') ? $title[$this->aFlexform['d']['fields']['c:'.$this->aDb[$i]['name']]] : $row['Field']);
					if($this->aDb[$i]['show'] == 1) $j++;
					$i++;
				}
				//show all fields if nothing is specified
				if(count($this->aFlexform['d']['fields']) <= 0) {
					for($i = 0; $i < count($this->aDb); $i++) {
						$this->aFlexform['d']['fields']['c:'.$this->aDb[$i]['name']] = $i;
						$this->aDb[$i]['title'] = (($title[$i] != '') ? $title[$i] : $this->aDb[$i]['name']);
					}
					if(count($this->aFlexform['a']['links']) > 0) {
						$i = count($this->aFlexform['d']['fields']);
						foreach($this->aFlexform['a']['links'] as $sName => $aConf) {
							$this->aFlexform['d']['fields']['l:'.$sName] = $i;
							if($title[$i] != '') $this->aFlexform['a']['links'][$sName]['title'] = $title[$i];
							$i++;
						}
					}
				}
			} else $content = $this->pi_getLL('error.database');
		}
		$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->processRequest($this, $this->prefixId);
		//fetch content
		if(!isset($content)) {
			if($this->aFlexform['d']['special'] != '') $content = $this->showSpecial();
			else $content = $this->showFull($this->aFlexform['d']['order']);
		}
		//create header stuff
		if($GLOBALS['TSFE']->additionalHeaderData['tx_mhomsqlio'] == '') {
			$sStyle = ($this->aFlexform['o']['nostyle'] ? '' : ('<link rel="stylesheet" type="text/css" href="'.t3lib_extMgm::siteRelPath($this->extKey).'res/tx_mhomsqlio_style.css" />'));
			if(t3lib_extMgm::isLoaded('date2cal')) $sCalPath = t3lib_extMgm::siteRelPath('date2cal').'js/jscalendar/';
			elseif(t3lib_extMgm::isLoaded('erotea_date2cal')) $sCalPath = t3lib_extMgm::siteRelPath('erotea_date2cal').'jscalendar/';
			$sHeadTmpl = $this->getTmpl('HEAD_INCLUDE_ONCE');
			if($this->aFlexform['a']['date'] == '' || !isset($sCalPath)) $sHeadTmpl = $this->cObj->substituteSubpart($sHeadTmpl, '###CAL_STUFF###', '', 0);
			$GLOBALS['TSFE']->additionalHeaderData['tx_mhomsqlio'] = $this->cObj->substituteMarkerArray($sHeadTmpl, array('STYLE' => $sStyle, 
				'XAJAX' => $GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId, '_sContElem'), 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey), 
				'PATH-CAL' => $sCalPath, 'L:js.filterall' => $this->pi_getLL('js.filterall'), 'L:js.sort' => $this->pi_getLL('js.sort'),
				'L:js.search' => $this->pi_getLL('js.search'), 'L:js.searching' => $this->pi_getLL('js.searching'), 'L:js.reload' => $this->pi_getLL('js.reload'),
				'L:js.first' => $this->pi_getLL('js.first'), 'L:js.previous' => $this->pi_getLL('js.previous'), 'L:js.last' => $this->pi_getLL('js.last'),
				'L:js.next' => $this->pi_getLL('js.next'), 'CE' => $this->sContElem, 'L:js.no-entries' => $this->pi_getLL('js.no-entries'), 'L:js.msg.del' => 
				$this->pi_getLL('msg.delSeveral'), 'CAL_STUFF' => '', 'ABORT-LINK' => $GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1Abort(\'all\');'), '###|###');
			$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->printJavascript();
		}
		//generate content
		return $this->pi_wrapInBaseClass($content);
	}
	
	function showFull($_order, $_bShowForm = true) {
		$tmpl_multiple = $this->getTmpl('list_multiple');
		//$aMarker = array('TABLE' => ('<div id="'.$this->sDiv.'">'.$this->showList($_order, '', true).'</div>'));
		$aMarker = array('TABLE' => ('<div id="'.$this->sDiv.'">'.$this->cObj->substituteMarkerArray($this->getTmpl('init_load'), array('CE' => $this->sContElem, 'LOAD' =>
			$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1Filter(\'\');', 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###').'</div>'));
		//searching
		if($this->aFlexform['g']['search'] == 1) $aMarker['SEARCH'] = $this->cObj->substituteMarkerArray($this->getTmpl('list_search'), array(
			'CE' => $this->sContElem, 'CLEAR-FILTER' => ($GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1Filter(\'\');'), 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###');
		else $aMarker['SEARCH'] = '';
		//adding
		if($this->aFlexform['g']['add'] == 1) $aMarker['ADD'] = $this->cObj->substituteMarkerArray($this->getTmpl('list_element_add'), array(
			'CE' => $this->sContElem, 'ADD-LINK' => $GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1ShowAdd(\'\');', 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###');
		else $aMarker['ADD'] = '';
		//multiple editing
		if($this->aFlexform['g']['multiple'] == 1 || $this->aFlexform['g']['csv'] != 'none') {
			$sOptions = '';
			$sDropDownHeadline = $this->pi_getLL('label.multiple.download');
			$sTmplOption = $this->getTmpl('LIST_MULTIPLE_OPTION');
			if($this->aFlexform['g']['edit'] == 1 && $this->aFlexform['g']['multiple'] == 1) {
				$sOptions .= $this->cObj->substituteMarkerArray($sTmplOption, array('TYPE' => 'edit', 'TEXT' => $this->pi_getLL('multiple.edit')), '###|###');
				$sDropDownHeadline = $this->pi_getLL('label.multiple.action');
			}
			if($this->aFlexform['g']['del'] == 1 && $this->aFlexform['g']['multiple'] == 1) {
				$sOptions .= $this->cObj->substituteMarkerArray($sTmplOption, array('TYPE' => 'del', 'TEXT' => $this->pi_getLL('multiple.del')), '###|###');
				$sDropDownHeadline = $this->pi_getLL('label.multiple.action');
			}
			if($this->aFlexform['g']['csv'] == 'both' || $this->aFlexform['g']['csv'] == 'all') $sOptions .= $this->cObj->substituteMarkerArray(
				$sTmplOption, array('TYPE' => 'csv-all', 'TEXT' => $this->pi_getLL('multiple.csv-all')), '###|###');
			if($this->aFlexform['g']['csv'] == 'both' || $this->aFlexform['g']['csv'] == 'part') $sOptions .= $this->cObj->substituteMarkerArray(
				$sTmplOption, array('TYPE' => 'csv-part', 'TEXT' => $this->pi_getLL('multiple.csv-part')), '###|###');
			$aMarker['MULTIPLE'] = $this->cObj->substituteMarkerArray($this->getTmpl('LIST_MULTIPLE'), array('CE' => $this->sContElem,
				'OPTIONS' => $sOptions, 'HEADLINE' => $sDropDownHeadline), '###|###');
		} else $aMarker['MULTIPLE'] = '';
		//results and show all button
		if($this->aFlexform['d']['show'] > 0) {
			$aMarker['RESULTS'] = $this->cObj->substituteMarkerArray($this->getTmpl('resultset'), array('CE' => $this->sContElem), '###|###');
			$aMarker['SHOW-ALL'] = (($this->aFlexform['g']['showall'] == 1) ? $this->cObj->substituteMarkerArray($this->getTmpl('show_all'), array('LINK' => 
				//'Table.page(document.getElementById(\''.$this->getName('table').'\'), 0, {\'pagesize\':\''.$this->nCntResult.'\'});', 'PATH-EXT' => 
				'Table.page(document.getElementById(\''.$this->getName('table').'\'), 0, {\'pagesize\':tx_mhomsqlio_fw(\''.$this->sContElem.'nRowsAll\', \'innerHTML\', \'\', 2)});', 'PATH-EXT' => 
				t3lib_extMgm::siteRelPath($this->extKey)), '###|###') : '');
			$aMarker['TABLE-RESULT'] = $this->cObj->substituteMarkerArray($this->pi_getLL('label.results'), array('RESULTS' => '<span id="'.$this->sContElem.'nRowsCurrent"></span>',
				'COMPLETE' => '<span id="'.$this->sContElem.'nRowsAll"></span>'), '###|###').'<br />'.$this->cObj->substituteMarkerArray($this->pi_getLL('label.page'), 
				array('PAGE' => '<span id="'.$this->sContElem.'nPageCurrent"></span>', 'COMPLETE' => '<span id="'.$this->sContElem.'nPageAll"></span>'), '###|###');
		} else $aMarker['RESULTS'] = $aMarker['SHOW-ALL'] = $aMarker['TABLE-RESULT'] = '';
		return (($_bShowForm ? ('<form name="'.$this->sForm.'" id="'.$this->sForm.'" onSubmit="javascript: return false;" action="" method="post">') : '').
			$this->replaceIncr($this->cObj->substituteMarkerArray($this->getTmpl('structure'), $aMarker, '###|###')).($_bShowForm ? '</form>' : '')).
			$this->getTmpl('MSG_DIV').$this->cObj->substituteMarkerArray($this->getTmpl('LOAD_DIV'), array('CE' => $this->sContElem, 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###');
	}
	
	function showSpecial() {
		$aMarker = array('TABLE' => ('<div id="'.$this->sDiv.'">'.$this->showSpecialList().'</div>'));
		//results and show all button
		if($this->aFlexform['d']['show'] > 0) {
			$aMarker['TABLE-RESULT'] = $this->cObj->substituteMarkerArray($this->pi_getLL('label.page'), array('PAGE' => 
				'<span id="'.$this->sContElem.'nPageCurrent"></span>', 'COMPLETE' => '<span id="'.$this->sContElem.'nPageAll"></span>'), '###|###');
			$aMarker['RESULTS'] = $this->cObj->substituteMarkerArray($this->getTmpl('resultset'), array('CE' => $this->sContElem), '###|###');
			$aMarker['SHOW-ALL'] = (($this->aFlexform['g']['showall'] == 1) ? $this->cObj->substituteMarkerArray($this->getTmpl('show_all'), array('LINK' => 
				'Table.page(document.getElementById(\''.$this->getName('table').'\'), 0, {\'pagesize\':\''.$this->nCntResult.'\'});', 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###') : '');
		} else $aMarker['RESULTS'] = $aMarker['SHOW-ALL'] = $aMarker['TABLE-RESULT'] = '';
		return $this->replaceIncr($this->cObj->substituteMarkerArray($this->getTmpl('structure_special'), $aMarker, '###|###')).
			$this->cObj->substituteMarkerArray($this->getTmpl('LOAD_DIV'), array('CE' => $this->sContElem, 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###');
	}
	
	function showList($_order, $_q = '') {
		$tmpl_pk = (($this->aFlexform['o']['pk'] == 1) ? $this->cObj->substituteMarkerArray($this->getTmpl('pk'), array('PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###') : '');
		$tmpl_del = $this->getTmpl('list_element_del');
		$tmpl_copy = $this->getTmpl('list_element_copy');
		$tmpl_mark = $this->getTmpl('list_element_mark');
		$sSql = $this->createSql($_order, (isset($_q['sql']) ? array($_q['sql']) : array()));
		if($this->aFlexform['a']['debugsql'] == 1) return '<strong>SQL STATEMENT:</strong> '.$sSql;
		if($oResult = $this->oDb->execute($sSql)) {
			$this->nCntResult = $this->oDb->sum($oResult);
			if($this->aFlexform['o']['use-manual'] == 1) {
				$sTmplManual = $this->getTmpl('MANUAL_LIST');
				if($aRow = $this->oDb->getAssoc($oResult)) {
					$aSplitNext = t3lib_div::trimExplode('###NEXT###', $this->cObj->getSubpart($sTmplManual, '###LIST_INNER###'), 1);
					$nSplitNext = count($aSplitNext);
					$sTmplFill = $this->cObj->getSubpart($sTmplManual, '###LIST_INNER_FILL###');
					$sRows = '';
					$j = 0;
					for($i = 0; $i < $this->oDb->sum($oResult); $i++) {
						foreach($aRow as $sKey => $sVal) $aRow[$sKey] = $this->prepareOutput($sVal, $sKey);
						$aRow['HOVER'] = 'javascript: tx_mhomsqlio_hover(this); return false;';
						$sRows .= $this->cObj->substituteMarkerArray($aSplitNext[$j], $aRow, '###|###');
						$j++;
						if(!isset($aSplitNext[$j])) $j = 0;
						$aRow = $this->oDb->getAssoc($oResult);
					}
					for($j; $j > 0 && $j < $nSplitNext; $j++) $sRows .= $this->cObj->substituteMarkerArray($sTmplFill, array('HOVER' => $aRow['HOVER']), '###|###');
				} else $sRows = $this->pi_getLL('error.empty');
				$sTmplList = $this->cObj->substituteSubpart($this->cObj->substituteSubpart($sTmplManual, '###LIST_INNER_FILL###', '', 0), '###LIST_INNER###', $sRows, 0);
				$sTableClass = 'table-autosort table-autostripe table-stripeclass:'.$this->aFlexform['o']['class-alternate'].' table-autofilter table-page-number:'.$this->sContElem.
					'nPageCurrent table-page-count:'.$this->sContElem.'nPageAll table-filtered-rowcount:'.$this->sContElem.'nRowsCurrent table-rowcount:'.$this->sContElem.'nRowsAll '.
					$this->aFlexform['o']['class-table'];
				if($this->aFlexform['d']['show'] > 0) {
					$sTableClass .= ' table-autopage:'.ceil($this->aFlexform['d']['show']/$nSplitNext);
					$sTableClass .= ' table-autopage-div:'.$nSplitNext;
					$sTableClass .= ' content-element:'.$this->sContElem;
					$sTableResult = $this->cObj->substituteMarkerArray($this->pi_getLL('label.page'), array('PAGE' => 
						'<span id="'.$this->sContElem.'nPageCurrent"></span>', 'COMPLETE' => '<span id="'.$this->sContElem.'nPageAll"></span>'), '###|###');
				} else $sTableResult = '';
				$content = $this->cObj->substituteMarkerArray($sTmplList, array('TABLE-ID' => $this->getName('table'), 'TABLE-CLASS' => $sTableClass, 'CE' => $this->sContElem,
					'TABLE-RESULT' => $sTableResult), '###|###');
			} else {
				//headers
				$aLine = array();
				//add check column and set additional columns
				if($this->aFlexform['g']['multiple'] == 1 || $this->aFlexform['g']['csv'] == 'both' || $this->aFlexform['g']['csv'] == 'part') {
					$nPlus = 1;
					$aLine[0] = '<input type="checkbox" name="tx_mhomsqlio_checkall-'.$this->sContElem.'" onClick="javascript: tx_mhomsqlio_check(\''.$this->sContElem.'\', this.checked);" />';
				} else $nPlus = 0;
				$oTable = t3lib_div::makeInstance('mh_table');
				$aAutofilter = t3lib_div::trimExplode(',', $this->aFlexform['g']['autofilter']);
				for($i = 0; $i < count($this->aDb); $i++) if($this->aDb[$i]['show'] == 1) {
					$nPos = $this->aFlexform['d']['fields']['c:'.$this->aDb[$i]['name']] + $nPlus;
					if($this->aFlexform['o']['pk'] == 1 && $this->aDb[$i]['pk'] == 1) $sPk = $tmpl_pk;
					else $sPk = '';
					$aLine[$nPos] = $sPk.$this->prepareOutput($this->aDb[$i]['title']);	//set title
					//sorting
					switch($this->aDb[$i]['type']) {
						case 'text': case 'tinytext': case 'blob': case 'varchar': case 'foreign':	$sType = 'ignorecase';	break;
						case 'datetime':	$sType = 'date';	break;
						case 'int':	$sType = (($this->aDb[$i]['tstamp'] == 1) ? 'ignorecase' : 'numeric');	break;
						default:	$sType = 'default';	break;
					}
					$this->formatHead($oTable, $nPos, $sType);
					//default sorting
					if($this->aDb[$i]['name'] == $this->aFlexform['d']['order'] || strtolower($this->aDb[$i]['name'].' asc') == strtolower($this->aFlexform['d']['order']))
						$oTable->appendHeaderAttribute($nPos, 'class', 'table-sorted-asc');
					elseif(strtolower($this->aDb[$i]['name'].' desc') == strtolower($this->aFlexform['d']['order'])) $oTable->appendHeaderAttribute($nPos, 'class', 'table-sorted-desc');
					//filtering
					if(in_array($this->aDb[$i]['title'], $aAutofilter) || in_array($this->aDb[$i]['name'], $aAutofilter))
						$oTable->appendHeaderAttribute($nPos, 'class', 'table-filterable');
				}
				//add additional columns for links
				if(count($this->aFlexform['a']['links']) > 0) foreach($this->aFlexform['a']['links'] as $sName => $aConf) {
					if(!isset($this->aFlexform['d']['fields']['l:'.$sName])) continue;
					$nPos = $this->aFlexform['d']['fields']['l:'.$sName] + $nPlus;
					$aLine[$nPos] = $aConf['title'];
					$this->formatHead($oTable, $nPos);
				}
				//add editing columns
				if(($this->aFlexform['g']['del'] + $this->aFlexform['g']['copy']) > 0) $aLine[] = $this->getEmptyCell();
				ksort($aLine);
				$oTable->addHeader($aLine);
				//check data
				if($this->oDb->sum($oResult) == 0 && $_q['sql'] != '' && $this->aFlexform['g']['search'] == 1) { //search criteria inserted but nothing found
					$oTable->addLine(array(str_replace('###SWORD###', $_q['sword'], $this->pi_getLL('error.nothing-found'))));
					$oTable->setCellAttribute(0, 0, 'colspan', (count($this->aFlexform['d']['fields']) + $nPlus + (($this->aFlexform['g']['del'] == 1) ? 1 : 0)));
				} elseif($this->oDb->sum($oResult) == 0) { //nothing found - without searching
					$oTable->addLine(array($this->pi_getLL('error.empty')));
					$oTable->setCellAttribute(0, 0, 'colspan', (count($this->aFlexform['d']['fields']) + $nPlus + (($this->aFlexform['g']['del'] == 1) ? 1 : 0)));
				} else {
					//data
					for($i = 0; $i < $this->oDb->sum($oResult); $i++) {
						$aRow = $this->oDb->get($oResult);
						$sId = $this->encryptId($this->getPk($aRow));
						$this->getSingleLine($sId, $oTable, $i, $aRow, $nPlus, $tmpl_mark, $tmpl_copy, $tmpl_del);
					}	
				}
				//formatting
				$oTable->setTableAttribute('id', $this->getName('table'));
				$oTable->setTableAttribute('cellpadding', '0');
				$oTable->setTableAttribute('cellspacing', '0');
				$oTable->setTableAttribute('width', '100%');
				if($this->aFlexform['o']['condform'] !== false) $oTable->setTableAttribute('class', 'table-autosort');
				else $oTable->setTableAttribute('class', 'table-autosort table-autostripe table-stripeclass:'.$this->aFlexform['o']['class-alternate']);
				$oTable->appendTableAttribute('class', 'table-autofilter');
				$oTable->appendTableAttribute('class', 'table-page-number:'.$this->sContElem.'nPageCurrent');
				$oTable->appendTableAttribute('class', 'table-page-count:'.$this->sContElem.'nPageAll');
				$oTable->appendTableAttribute('class', 'table-filtered-rowcount:'.$this->sContElem.'nRowsCurrent');
				$oTable->appendTableAttribute('class', 'table-rowcount:'.$this->sContElem.'nRowsAll');
				$oTable->appendTableAttribute('class', 'content-element:'.$this->sContElem);
				$oTable->appendTableAttribute('class', $this->aFlexform['o']['class-table']);
				if($this->aFlexform['d']['show'] > 0) $oTable->appendTableAttribute('class', 'table-autopage:'.$this->aFlexform['d']['show']);
				//finish
				$content = $oTable->getTable();
			}
		} else $content = $this->pi_getLL('error.sql');
		return $content;
	}
	
	function showSpecialList() {
		if($this->aFlexform['a']['debugsql'] == 1) return '<strong>SQL STATEMENT:</strong> '.$this->aFlexform['d']['special'];
		if($oResult = $this->oDb->execute($this->aFlexform['d']['special'])) {
			$this->nCntResult = $this->oDb->sum($oResult);
			//manual mode or normal table mode
			if($this->aFlexform['o']['use-manual'] == 1) {
				$sTmplManual = $this->getTmpl('MANUAL_LIST');
				if($aRow = $this->oDb->getAssoc($oResult)) {
					$aSplitNext = t3lib_div::trimExplode('###NEXT###', $this->cObj->getSubpart($sTmplManual, '###LIST_INNER###'), 1);
					$nSplitNext = count($aSplitNext);
					$sTmplFill = $this->cObj->getSubpart($sTmplManual, '###LIST_INNER_FILL###');
					$sRows = '';
					$j = 0;
					for($i = 0; $i < $this->oDb->sum($oResult); $i++) {
						foreach($aRow as $sKey => $sVal) $aRow[$sKey] = $this->prepareOutput($sVal, $sKey);
						$aRow['HOVER'] = 'javascript: tx_mhomsqlio_hover(this); return false;';
						$sRows .= $this->cObj->substituteMarkerArray($aSplitNext[$j], $aRow, '###|###');
						$j++;
						if(!isset($aSplitNext[$j])) $j = 0;
						$aRow = $this->oDb->getAssoc($oResult);
					}
					for($j; $j > 0 && $j < $nSplitNext; $j++) $sRows .= $this->cObj->substituteMarkerArray($sTmplFill, array('HOVER' => $aRow['HOVER']), '###|###');
				} else $sRows = $this->pi_getLL('error.empty');
				$sTmplList = $this->cObj->substituteSubpart($this->cObj->substituteSubpart($sTmplManual, '###LIST_INNER_FILL###', '', 0), '###LIST_INNER###', $sRows, 0);
				$sTableClass = 'table-autosort table-autostripe table-stripeclass:'.$this->aFlexform['o']['class-alternate'].' table-autofilter table-page-number:'.$this->sContElem.
					'nPageCurrent table-page-count:'.$this->sContElem.'nPageAll table-filtered-rowcount:'.$this->sContElem.'nRowsCurrent table-rowcount:'.$this->sContElem.'nRowsAll '.
					$this->aFlexform['o']['class-table'];
				if($this->aFlexform['d']['show'] > 0) {
					$sTableClass .= ' table-autopage:'.ceil($this->aFlexform['d']['show']/$nSplitNext);
					$sTableClass .= ' table-autopage-div:'.$nSplitNext;
					$sTableClass .= ' content-element:'.$this->sContElem;
					$sTableResult = $this->cObj->substituteMarkerArray($this->pi_getLL('label.page'), array('PAGE' => 
						'<span id="'.$this->sContElem.'nPageCurrent"></span>', 'COMPLETE' => '<span id="'.$this->sContElem.'nPageAll"></span>'), '###|###');
				} else $sTableResult = '';
				$content = $this->cObj->substituteMarkerArray($sTmplList, array('TABLE-ID' => $this->getName('table'), 'TABLE-CLASS' => $sTableClass, 'CE' => $this->sContElem,
					'TABLE-RESULT' => $sTableResult), '###|###');
			} else {
				//header
				$aLine = array();
				$oTable = t3lib_div::makeInstance('mh_table');
				$aAutofilter = t3lib_div::trimExplode(',', $this->aFlexform['g']['autofilter']);
				if($aRow = $this->oDb->getAssoc($oResult)) {
					$i = 0;
					foreach($aRow as $sCol => $sVal) {
						$aLine[$i] = $this->prepareOutput($sCol);	//title
						$this->formatHead($oTable, $i, 'default');	//sorting
						//filtering
						if(in_array($sCol, $aAutofilter)) $oTable->appendHeaderAttribute($i, 'class', 'table-filterable');
						$i++;
					}
					$oTable->addHeader($aLine);
					//data
					for($i = 0; $i < $this->oDb->sum($oResult); $i++) {
						$aLine = array();
						foreach($aRow as $sCol => $sVal) $aLine[] = $this->prepareOutput($sVal, $sCol);
						$oTable->setRowAttribute($i, 'onMouseOver', 'javascript: tx_mhomsqlio_hover(this); return false;');
						$oTable->addLine($aLine);
						$aRow = $this->oDb->getAssoc($oResult);
					}
				} else $oTable->addLine(array($this->pi_getLL('error.empty')));
				//formatting
				$oTable->setTableAttribute('id', $this->getName('table'));
				$oTable->setTableAttribute('cellpadding', '0');
				$oTable->setTableAttribute('cellspacing', '0');
				$oTable->setTableAttribute('width', '100%');
				$oTable->setTableAttribute('class', 'table-autosort table-autostripe table-stripeclass:'.$this->aFlexform['o']['class-alternate']);
				$oTable->appendTableAttribute('class', 'table-autofilter');
				$oTable->appendTableAttribute('class', 'table-page-number:'.$this->sContElem.'nPageCurrent');
				$oTable->appendTableAttribute('class', 'table-page-count:'.$this->sContElem.'nPageAll');
				$oTable->appendTableAttribute('class', 'table-filtered-rowcount:'.$this->sContElem.'nRowsCurrent');
				$oTable->appendTableAttribute('class', 'table-rowcount:'.$this->sContElem.'nRowsAll');
				$oTable->appendTableAttribute('class', 'content-element:'.$this->sContElem);
				$oTable->appendTableAttribute('class', $this->aFlexform['o']['class-table']);
				if($this->aFlexform['d']['show'] > 0) $oTable->appendTableAttribute('class', 'table-autopage:'.$this->aFlexform['d']['show']);
				//finish
				$content = $oTable->getTable();
			}
		} else $content = $this->pi_getLL('error.sql');
		return $content;
	}
	
	function replaceIncr($_sString, $_sPattern = '###incr###') {
		$aSplit = explode($_sPattern, $_sString);
		$sReturn = $aSplit[0];
		for($i = 1; $i < count($aSplit); $i++) $sReturn .= $i.$aSplit[$i];
		return $sReturn;
	}
	
	function prepareUtf8($_sValue, $_bForceUtf8 = false) {
		//UTF-8 check from http://w3.org/International/questions/qa-forms-utf-8.html
		if(preg_match('%^(?:
			 [\x09\x0A\x0D\x20-\x7E]            # ASCII
		   | [\xC2-\xDF][\x80-\xBF]            # non-overlong 2-byte
		   |  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
		   | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
		   |  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
		   |  \xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
		   | [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
		   |  \xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
		)*$%xs', $_sValue)) {
			if($this->aFlexform['g']['charset'] == 'UTF-8' || $_bForceUtf8) return $_sValue;
			else return utf8_decode($_sValue);
		} else {
			if($this->aFlexform['g']['charset'] == 'UTF-8' || $_bForceUtf8) return utf8_encode($_sValue);
			else return $_sValue;
		}
	}
	
	function prepareInput(&$_aInsert, $_sName, $_mValue, $_bOverwrite = true) {
		if(!isset($_aInsert[$_sName]) || $_bOverwrite == true) {
			if(isset($this->aFlexform['a']['callback'][$_sName]['in']))
				$_mValue = call_user_func(array($this->oCallback, $this->aFlexform['a']['callback'][$_sName]['in']), $_mValue);
			$nField = $this->findDbParam('name', $_sName, '__NR', 1);
			switch($this->aDb[$nField]['type']) {
				case 'int':
				case 'bigint':
				case 'mediumint':
				case 'smallint':
				case 'tinyint':
					if($this->aDb[$nField]['tstamp'] == 1) $_mValue = $this->getTstamp($_mValue);
					$_aInsert[$_sName] = intval($_mValue);
					break;
				case 'float':
				case 'double':
				case 'numeric':
					$_aInsert[$_sName] = doubleval($_mValue);
					break;
				case 'bool':
					$_aInsert[$_sName] = (($_mValue == 'on' || $_mValue == 1 || $_mValue == 'checked' || $_mValue == '1') ? 1 : 0);
					break;
				case 'file':
					$tmpl = 'file';
					break;
				case 'foreign':
					$_aInsert[$_sName] = $_mValue;
					break;
				case 'date':
				case 'enum':
				case 'varchar':
				case 'binary':
				default: //case 'area': blob, text
					$_aInsert[$_sName] = $this->prepareUtf8($_mValue);
					break;
			}
		}
	}
	
	function prepareOutput($_sValue, $_sFieldname = '', $_bExplicitNoHtmlEntities = false, $_bForCsv = false) {
		$nField = $this->findDbParam('name', $_sFieldname, '__NR', 1);
		switch($this->aDb[$nField]['type']) {
			case 'bool':
				return $this->cObj->substituteMarkerArray((($_sValue == 'on' || $_sValue == 1 || $_sValue == 'checked' || $_sValue == '1') ? $this->getTmpl('SHOW_BOOL_TRUE') : $this->getTmpl('SHOW_BOOL_FALSE')),
					array('PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###');
				break;
			default:
				if($this->aDb[$nField]['tstamp'] == 1) $_sValue = date($this->aFlexform['a']['format'], $_sValue);
				$_sValue = (($this->aFlexform['a']['nohtmlentities'] == 1 || $_bExplicitNoHtmlEntities === true) ? $this->prepareUtf8($_sValue) : 
					$this->prepareUtf8(htmlentities($_sValue, ENT_NOQUOTES, $this->aFlexform['g']['charset'])));
				if($_sFieldname != '' && isset($this->aFlexform['a']['callback'][$_sFieldname]['out']))
					return call_user_func(array($this->oCallback, $this->aFlexform['a']['callback'][$_sFieldname]['out']), $_sValue, $_bForCsv);
				else return $_sValue;
				break;
		}
	}
	
	function createSql($_order = '', $_where = array(), $_bSelectForDisplay = false) {
		$where = $_where;
		$sTemp = $this->getWhere();
		if($sTemp != '') $where[] = $sTemp;
		if($this->aFlexform['d']['criteria'] != '') {
			$aMarker = array('ID' => $GLOBALS['TSFE']->id, 'UID' => $GLOBALS['TSFE']->fe_user->user['uid'], 'USERNAME' => 
				$GLOBALS['TSFE']->fe_user->user['username'], 'EMAIL' => $GLOBALS['TSFE']->fe_user->user['email'], 
				'NAME' => $GLOBALS['TSFE']->fe_user->user['name']);
			$where[] = $this->cObj->substituteMarkerArray($this->aFlexform['d']['criteria'], $aMarker, '###|###');
		}
		if($this->aFlexform['d']['login-uid'] != '') {
			if($GLOBALS['TSFE']->fe_user->user['uid'] > 0) $where[] = $this->aFlexform['d']['login-uid'].' = '.$GLOBALS['TSFE']->fe_user->user['uid'];
			else $where[] = '1 = 0';
		}
		if($this->aFlexform['d']['login-username'] != '') {
			if($GLOBALS['TSFE']->fe_user->user['username'] != '') $where[] = $this->aFlexform['d']['login-username'].' = \''.$GLOBALS['TSFE']->fe_user->user['username'].'\'';
			else $where[] = '1 = 0';
		}
		$sWhere = ((count($where) > 0) ? (' WHERE '.implode(' AND ', $where)) : '');
		if($_order == '') $_order = ($this->aFlexform['d']['order'] ? $this->aFlexform['d']['order'] : ($this->aDb[0]['name'].' ASC'));
		$sLeftJoin = $sSelect = '';
		if(count($this->aForeign) > 0) foreach($this->aForeign as $sField => $aConf)  if ($sField != '') {
			$sLeftJoin .= ' LEFT JOIN '.$aConf['table'].' ON ('.$this->aFlexform['d']['table'].'.'.$aConf['fk'].' = '.$aConf['table'].'.'.$aConf['pk'];
			$aConf['where'] = preg_replace('/\[.+\]/', '', $aconf['where']);
			$sLeftJoin .= (($aConf['where'] != '') ? (' AND '.$aConf['where'].') ') : ') ');
			$sSelect .= ', '.(($aConf['show']{0} == '#') ? substr($aConf['show'], 1) : ($aConf['table'].'.'.$aConf['show'])).' AS `'.$aConf['table'].'-'.$aConf['show'].'`';
		}
		if($_bSelectForDisplay) {
			$aSelect = array();
			if($this->aFlexform['g']['multiple'] == 1 || $this->aFlexform['g']['csv'] == 'both' || $this->aFlexform['g']['csv'] == 'part') $nPlus = 1;
			else $nPlus = 0;
			for($i = 0; $i < count($this->aDb); $i++) if($this->aDb[$i]['show'] == 1) {
				$sField = (($this->aDb[$i]['type'] == 'foreign') ? (($this->aForeign[$this->aDb[$i]['name']]['show']{0} == '#') ? substr($this->aForeign[$this->aDb[$i]['name']]['show'], 1) : ($this->aForeign[$this->aDb[$i]['name']]['table'].'.'.$this->aForeign[$this->aDb[$i]['name']]['show'])) : $this->aDb[$i]['name']);
				$nPos = $this->aFlexform['d']['fields']['c:'.$this->aDb[$i]['name']] + $nPlus;
				$aSelect[$nPos] = $sField.' AS `'.$this->aDb[$i]['title'].'`';
			}
			foreach($this->aFlexform['a']['links'] as $sName => $aConf) {
				$aExplodeLink = preg_split('/(\#\#\#[^ ,\#]+\#\#\#)/', $aConf['caption'], -1, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
				$aField = array();
				foreach($aExplodeLink as $sExplodeLink) if($sExplodeLink != '') $aField[] = ((substr($sExplodeLink, 0, 3) == '###' && substr($sExplodeLink, -3) == '###') ? 
					('`'.substr($sExplodeLink, 3, (strlen($sExplodeLink) - 6)).'`') : ('\''.addslashes($sExplodeLink).'\''));
				if(count($aField) > 0) {
					$nPos = $this->aFlexform['d']['fields']['l:'.$sName] + $nPlus;
					$aSelect[$nPos] = 'CONCAT('.implode(', ', $aField).') AS `'.$aConf['title'].'`';
				}
			}
			ksort($aSelect);
			$sSelect = implode(', ', $aSelect);
		} else $sSelect = $this->aFlexform['d']['table'].'.*'.$sSelect;
		return 'SELECT '.$sSelect.' FROM '.$this->aFlexform['d']['table'].$sLeftJoin.$sWhere.' ORDER BY '.$_order;
	}
	
	function getWhere($_type = 'del', $_id = array()) {
		switch($_type) {
			case 'pk':
				$where = array();
				foreach($this->aDb as $col) {
					if($col['pk'] == 1) {
						$temp = $this->aFlexform['d']['table'].'.'.$col['name'].' = ';
						if($col['type'] != 'int') $temp .= '\''.addslashes($_id[$col['name']]).'\'';
						else $temp .= intval($_id[$col['name']]);
						$where[] = $temp;
					}
				}
				return '('.implode(' AND ', $where).')';
				break;
			case 'del':
				if(is_array($this->aFlexform['a']['changedel'])) {
					return $this->aFlexform['d']['table'].'.'.$this->aFlexform['a']['changedel']['col'].' = \''.$this->aFlexform['a']['changedel']['undel'].'\'';
				}
				break;
		}
		return '';
	}
	
	function formatHead(&$_oTable, $_nPos, $_sType = 'default') {
		$_oTable->setHeaderAttribute($_nPos, 'style', 'cursor: pointer;');
		$_oTable->setHeaderAttribute($_nPos, 'class', 'table-sortable');
		if(isset($this->aFlexform['o']['width'][$_nPos])) $_oTable->appendHeaderAttribute($_nPos, 'style', 'width: '.$this->aFlexform['o']['width'][$_nPos]);
		$_oTable->appendHeaderAttribute($_nPos, 'class', 'table-sortable:'.$_sType);
	}
	
	function getPk($_aRow) {
		$aPk = array();
		$bFound = false;
		foreach($this->aDb as $aCol) if($aCol['pk'] == 1 && isset($_aRow[$aCol['name']])) {
			$aPk[$aCol['name']] = $_aRow[$aCol['name']];
			$bFound = true;
		}
		return ($bFound ? $aPk : false);
	}
	
	function encryptId($_aId) {
		$header = $string = '';
		foreach($_aId as $key => $value) {
			$header .= strlen($string).'_';
			$string .= $key;
			$header .= strlen($string).'-';
			$string .= $value;
		}
		return addslashes(str_replace('"', '\'', substr($header, 0, strlen($header) - 1).':'.$string));
	}
	
	function decryptId($_sId) {
		$temp = explode(':', $_sId);
		$header = $temp[0];
		$length = strlen($header) + 1;
		$string = stripslashes(str_replace('\'', '"', substr($_sId, $length, strlen($_sId) - $length)));
		$fields = explode('-', $header);
		$aId = array();
		for($i = 0; $i < count($fields); $i++) {
			$temp = explode('_', $fields[$i]);
			if(($i+1) == count($fields)) $stop = strlen($string) - $temp[1];
			else {
				$temp2 = explode('_', $fields[$i+1]);
				$stop = $temp2[0] - $temp[1];
			}
			$aId[substr($string, $temp[0], ($temp[1] - $temp[0]))] = substr($string, $temp[1], $stop);
		}
		return $aId;
	}
	
	function getContents($_file) {
		$temp = $this->cObj->fileResource($_file);
		if($temp == '') $temp = t3lib_div::getUrl($_file);
		if($temp == '') $temp = @file_get_contents($_file);
		return $temp;
	}
	
	function getName($_sType = 'add', $_mId = array(), $_sName = '') {
		if(is_array($_mId)) $_mId = $this->encryptId($_mId);
		switch($_sType) {
			case 'edit':	return 'edit-'.$_mId.'-'.$_sName;	break;
			case 'add':	return 'add-'.$_sName;	break;
			case 'row':	return 'row-'.$this->sContElem.(('' != $this->sContElem) ? '-' : '').$_mId;	break;
			case 'table':	return 'mh_omsqlio-table-'.$this->sContElem;	break;
		}
	}
	
	function getDateFormat() {
		switch($this->aFlexform['a']['format']) {
			case 'Y-m-d':	return '%Y-%m-%d';
				break;
			case 'd.m.y':	return '%d.%m.%y';
				break;
			case 'd.m.Y':	return '%d.%m.%Y';
				break;
			case 'd.m.Y H:i:s':	return '%d.%m.%Y %H:%M:%S';
				break;
			case 'd.m.Y h:i:s':	return '%d.%m.%Y %I:%M:%S';
				break;
			case 'd.m.Y H:i':	return '%d.%m.%Y %H:%M';
				break;
			case 'd.m.Y h:i':	return '%d.%m.%Y %I:%M';
				break;
			case 'Y-m-d H:i:s':	return '%Y-%m-%d %H:%M:%S';
				break;
			case 'Y-m-d h:i:s':	return '%Y-%m-%d %I:%M:%S';
				break;
			case 'Y-m-d H:i':	return '%Y-%m-%d %H:%M';
				break;
			case 'Y-m-d h:i':	return '%Y-%m-%d %I:%M';
				break;
		}
	}
	
	function getTstamp($_date) {
		switch($this->aFlexform['a']['format']) {
			case 'Y-m-d':	return mktime(0, 0, 0, substr($_date, 5, 7), substr($_date, 8, 10), substr($_date, 0, 4));
				break;
			case 'd.m.y':	return mktime(0, 0, 0, substr($_date, 3, 5), substr($_date, 0, 2), substr($_date,6, 8));
				break;
			case 'd.m.Y':	return mktime(0, 0, 0, substr($_date, 3, 5), substr($_date, 0, 2), substr($_date, 6, 10));
				break;
			case 'd.m.Y H:i:s':	return mktime(substr($_date, 11, 13), substr($_date, 14, 16), substr($_date, 17, 19), substr($_date, 3, 5), substr($_date, 0, 2), substr($_date, 6, 10));
				break;
			case 'd.m.Y h:i:s':	return mktime(substr($_date, 11, 13), substr($_date, 14, 16), substr($_date, 17, 19), substr($_date, 3, 5), substr($_date, 0, 2), substr($_date, 6, 10));
				break;
			case 'd.m.Y H:i':	return mktime(substr($_date, 11, 13), substr($_date, 14, 16), 0, substr($_date, 3, 5), substr($_date, 0, 2), substr($_date, 6, 10));
				break;
			case 'd.m.Y h:i':	return mktime(substr($_date, 11, 13), substr($_date, 14, 16), 0, substr($_date, 3, 5), substr($_date, 0, 2), substr($_date, 6, 10));
				break;
			case 'Y-m-d H:i:s':	return mktime(substr($_date, 11, 13), substr($_date, 14, 16), substr($_date, 17, 19), substr($_date, 3, 5), substr($_date, 0, 2), substr($_date, 6, 10));
				break;
			case 'Y-m-d h:i:s':	return mktime(substr($_date, 11, 13), substr($_date, 14, 16), substr($_date, 17, 19), substr($_date, 3, 5), substr($_date, 0, 2), substr($_date, 6, 10));
				break;
			case 'Y-m-d H:i':	return mktime(substr($_date, 11, 13), substr($_date, 14, 16), 0, substr($_date, 5, 7), substr($_date, 8, 10), substr($_date, 0, 4));
				break;
			case 'Y-m-d h:i':	return mktime(substr($_date, 11, 13), substr($_date, 14, 16), 0, substr($_date, 5, 7), substr($_date, 8, 10), substr($_date, 0, 4));
				break;
		}
	}
	
	function findDbParam($_sFind, $_sValue, $_sReturn, $_nHandleShownOnes = 0) {
		foreach($this->aDb as $sField => $aConf) if((($_nHandleShownOnes == 0 && $aConf['show'] == 1) || $_nHandleShownOnes == 1 || ($_nHandleShownOnes == 2 && $aConf['show'] == 0))
			&& $aConf[$_sFind] == $_sValue) return (($_sReturn == '__NR') ? $sField : $aConf[$_sReturn]);
		if(count($this->aFlexform['a']['links']) <= 0) return '';
		foreach($this->aFlexform['a']['links'] as $sName => $aConf) if($aConf[$_sFind] == $_sValue) return (($_sReturn == 'name') ? $sName : $aConf[$_sReturn]);
		return '';
	}
	
	function getSingleLine($_mId, &$_oTable, $_i = 0, $_aRow = array(), $_nPlus = -1, $_sTmplMark = '', $_sTmplCopy = '', $_sTmplDel = '') {
		if(count($_aRow) <= 0) {	//preparation: if no data is given, fetch data
			$aId = (!is_array($_mId) ? $this->decryptId($_mId) : $_mId);
			$_aRow = $this->oDb->getOneRow($this->createSql('', array($this->getWhere('pk', $this->getPk($aId)))));
		}
		if($_nPlus < 0) {	//preparation: if $_nPlus is not given (-1) check if there is a nPlus column
			if($this->aFlexform['g']['multiple'] == 1 || $this->aFlexform['g']['csv'] == 'both' || $this->aFlexform['g']['csv'] == 'part') $_nPlus = 1;
			else $_nPlus = 0;
		}
		//preparation: fetch templates if they're not given
		if($_sTmplMark == '') $_sTmplMark = $this->getTmpl('list_element_mark');
		if($_sTmplCopy == '' && $this->aFlexform['g']['copy'] == 1 && $this->aFlexform['g']['add'] == 1) $_sTmplCopy = $this->getTmpl('list_element_copy');
		if($_sTmplDel == '' && $this->aFlexform['g']['del'] == 1) $_sTmplDel  = $this->getTmpl('list_element_del');
		//now do something
		$aLine = $aAfter = array();
		$sRow = $this->getName('row', $_mId);
		if($_nPlus == 1) {
			$aLine[0] = $this->cObj->substituteMarkerArray($_sTmplMark, array('ROW' => $sRow, 'ID' => $_mId), '###|###');
			if(strtolower(get_class($_oTable)) == 'xajaxresponse') $aLine[0] = addslashes($aLine[0]);
		}
		foreach($this->aDb as $col) if($col['show'] == 1) {
			$nPos = $this->aFlexform['d']['fields']['c:'.$col['name']] + $_nPlus;
			$sColName = (($col['type'] == 'foreign') ? ($this->aForeign[$col['name']]['table'].'-'.$this->aForeign[$col['name']]['show']) : $col['name']);
			$aLine[$nPos] = nl2br($this->prepareOutput($_aRow[$sColName], $sColName));
			if($aLine[$nPos] == '') $aLine[$nPos] = $this->getEmptyCell();
			if(strtolower(get_class($_oTable)) == 'xajaxresponse') $aLine[$nPos] = addslashes($aLine[$nPos]);
			if($this->aFlexform['g']['edit'] == 1) {
				switch(strtolower(get_class($_oTable))) {
					case 'mh_table':
						$_oTable->setCellAttribute($_i, $nPos, 'onclick', 'javascript: tx_mhomsqlio_edit(\''.$this->sContElem.'\', this); return false;');
						$_oTable->setCellAttribute($_i, $nPos, 'style', 'cursor: pointer;');
						break;
					case 'xajaxresponse':
						$aAfter[] = 'tx_mhomsqlio_setEvent(\''.$sRow.'\', '.$nPos.', \'onclick\', \'tx_mhomsqlio_edit(\\\''.$this->sContElem.'\\\', this);\', 0)';
						$aAfter[] = 'tx_mhomsqlio_setEvent(\''.$sRow.'\', '.$nPos.', \'style.cursor\', \'\\\'pointer\\\'\', 1)';
						break;
				}
			}
		}
		if(count($this->aFlexform['a']['links']) > 0) foreach($this->aFlexform['a']['links'] as $sName => $aConf) {
			if(!isset($this->aFlexform['d']['fields']['l:'.$sName])) continue;
			if($aConf['link'] == '') $sLink = '';
			else {
				$sLink = trim($this->cObj->substituteMarkerArray($aConf['link'], $_aRow, '###|###'));
				if(is_numeric($sLink)) $sLink = $this->pi_getPageLink($sLink);
				else $sLink = $this->prepareOutput($sLink, $sName);
			}
			$sTempText = $this->prepareOutput($this->cObj->substituteMarkerArray($aConf['caption'], $_aRow, '###|###'), $sName);
			$aLine[($_nPlus + $this->aFlexform['d']['fields']['l:'.$sName])] = (($sLink != '') ? ('<a href="'.str_replace('"', '&quot;', $sLink).'">'.(($sTempText != '') ? $sTempText : $this->getEmptyCell()).'</a>') : (($sTempText != '') ? $sTempText : $this->getEmptyCell()));
			if(strtolower(get_class($_oTable)) == 'xajaxresponse') $aLine[($_nPlus + $this->aFlexform['d']['fields']['l:'.$sName])] =  addslashes($aLine[($_nPlus + $this->aFlexform['d']['fields']['l:'.$sName])]);
		}
		if(($this->aFlexform['g']['del'] + $this->aFlexform['g']['copy']) > 0) {
			$sEditing = '';
			if($this->aFlexform['g']['copy'] == 1 && $this->aFlexform['g']['add'] == 1) $sEditing .= $this->cObj->substituteMarkerArray($_sTmplCopy, array('LINK' => 
				$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1ShowAdd(\''.$_mId.'\');', 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###');
			if($this->aFlexform['g']['del'] == 1) $sEditing .= $this->cObj->substituteMarkerArray($_sTmplDel, array('ID' => $_mId, 'MSG' => $this->pi_getLL('msg.del'), 'CE' => 
				$this->sContElem, 'PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###');
			$aLine[] = ((strtolower(get_class($_oTable)) == 'xajaxresponse') ? addslashes($sEditing) : $sEditing);
		}
		ksort($aLine);
		switch(strtolower(get_class($_oTable))) {
			case 'mh_table':
				$_oTable->setRowAttribute($_i, 'onMouseOver', 'javascript: tx_mhomsqlio_hover(this); return false;');
				$_oTable->setRowAttribute($_i, 'id', $sRow);
				if($this->aFlexform['o']['condform'] !== false) $_oTable->setRowAttribute($_i, 'style', 'background-color: '.$this->fetchColor($_aRow));
				$_oTable->addLine($aLine);
				break;
			case 'xajaxresponse':
				$_oTable->script('tx_mhomsqlio_replaceRow(\''.$this->sContElem.'\', \''.$sRow.'\', new Array(\''.str_replace(chr(13), '', str_replace(chr(10), '', implode('\', \'', $aLine))).'\'));');
				$_oTable->script('tx_mhomsqlio_setEvent(\''.$sRow.'\', -1, \'onmouseover\', \'tx_mhomsqlio_hover(this);\', 0)');
				if($this->aFlexform['o']['condform'] !== false) $_oTable->script('tx_mhomsqlio_color(\''.$sRow.'\', \''.$this->fetchColor($_aRow).'\');');
				foreach($aAfter as $sScript) $_oTable->script($sScript);
				break;
		}
	}
	
	function getTmpl($_part = '') {
		return $this->cObj->getSubpart($this->sTemplate, '###'.strtoupper($_part).'###');
	}
	
	function getFormField(&$_aAfter, $_name, $_nDbId, $_content = '', $_length = 0, $_onclick = '') {
		switch($this->aDb[$_nDbId]['type']) {
			case 'int':
			case 'bigint':
			case 'float':
			case 'double':
			case 'mediumint':
			case 'numeric':
			case 'smallint':
			case 'tinyint':
				$mArr['NAME'] = $_name;
				if($this->aDb[$_nDbId]['tstamp'] == 1) {
					$mArr['VALUE'] = date($this->aFlexform['a']['format'], $_content);
					$tmpl = $this->getTmpl('form_text');
				} else {
					$tmpl = $this->getTmpl('form_int');
					$mArr['VALUE'] = $_content;
					$mArr['LENGTH'] = (($_length > 0) ? $_length : 254);
				}
				if($this->aDb[$_nDbId]['datesel'] == 1) {
					if($_content == '') $mArr['VALUE'] = date($this->aFlexform['a']['format']);
					$tmpl = $this->getTmpl('form_date');
					$mArr['PATH-EXT'] = t3lib_extMgm::siteRelPath($this->extKey);
					$_aAfter[] = $this->cObj->substituteMarkerArray($this->getTmpl('CAL_SETUP'), array('INPUT' => $_name, 'FORMAT' => 
						$this->getDateFormat(), 'BUTTON' => ($_name.'-trigger')), '###|###');
				}
				break;
			case 'bool':
				$tmpl = $this->getTmpl('form_bool');
				$mArr['NAME'] = $_name;
				$mArr['CHECKED'] = (($_content == 1) ? 'checked="checked"' : '');
				$mArr['ONCLICK'] = (($_onclick != '') ? $_onclick : '');
				break;
			case 'varchar':
			case 'binary':
				$tmpl = $this->getTmpl('form_text');
				$mArr['NAME'] = $_name;
				//$mArr['VALUE'] = stripslashes(str_replace('"', '\'', $this->prepareUtf8($_content)));
				$mArr['VALUE'] = stripslashes(str_replace('"', '\'', $this->prepareUtf8($_content, true)));
				$mArr['LENGTH'] = (($_length > 0) ? $_length : 254);
				break;
			case 'file':
				$tmpl = 'file';
				break;
			case 'enum':
				$aValues = explode(',', $_length);
				if(count($aValues) > 0) {
					$this->oSelect->clear($_name);
					foreach($aValues as $sVal) {
						$sVal = substr($sVal, 1, (strlen($sVal) - 2));
						$this->oSelect->add($sVal, $sVal, (($sVal == $_content) ? true : false));
					}
					$tmpl = $this->oSelect->getHtml();
				} else $tmpl = '<input type="text" name="'.$_name.'" readOnly="readonly" value="'.$_content.'" />';
				break;
			case 'foreign':
				$this->oSelect->clear($_name);
				$this->oSelect->sql($this->oDb, ('SELECT '.$this->aForeign[$_length]['pk'].', '.(($this->aForeign[$_length]['show']{0} == '#') ? 
					substr($this->aForeign[$_length]['show'], 1) : $this->aForeign[$_length]['show']).' FROM '.
					$this->aForeign[$_length]['table'].(($this->aForeign[$_length]['where'] != '') ? (' WHERE '.str_replace(array('[', ']'), '', $this->aForeign[$_length]['where'])) : ' ').
					$this->aForeign[$_length]['order']));
				if($_content != '') $this->oSelect->setSelected($_content);
				$tmpl = addslashes($this->oSelect->getHtml());
				//$tmpl = str_replace('\'', '\\\\\'', addslashes($this->oSelect->getHtml()));
				break;
			default: //case 'area': blob, text
				if(1 == 2 && $this->aDb[$_nDbId]['rte'] == 1) {	//currently the RTE doesn't work together with XAJAX (normally loaded it works nearly perfectly)
					include_once(t3lib_extMgm::extPath('mh_omsqlio').'pi1/class.tx_mhomsqlio_rte.php');
					$oRte = t3lib_div::makeInstance('tx_mhomsqlio_rte');
					$mArr = $oRte->draw($_content, $this->sForm, $_name);
					$_aAfter[] = $mArr['JS-POST'];
					//$mArr['JS-POST'] = '';
					if(is_array($mArr)) $tmpl = $this->getTmpl('form_rte');
				}
				if(!isset($tmpl)) {
					$mArr['NAME'] = $_name;
					$tmpl = $this->getTmpl('form_area');
					$mArr['VALUE'] = t3lib_div::formatForTextarea($this->prepareUtf8(stripslashes($_content), true));
					$aPos = array(0 => 0);
					$i = 0;
					while(strpos($mArr['VALUE'], $this->sLinebreak, ($i+1)) !== false) $aPos[] = $i = strpos($mArr['VALUE'], $this->sLinebreak, ($i+1));
					$_aAfter[] = 'tx_mhomsqlio_setTextareaLinebreak(\''.$mArr['NAME'].'\', new Array('.implode(',', $aPos).'), '.((TYPO3_OS == 'WIN') ? 2 : 1).');';
				}
				break;
		}
		return $this->cObj->substituteMarkerArray($tmpl, $mArr, '###|###');
	}
	
	function mail($_sType) {
		if(($this->aFlexform['g']['ifmail'] == 'all' || strpos($this->aFlexform['g']['ifmail'], $_sType) !== false) && $this->aFlexform['g']['mail'] != '') {
			$aMarker = array('TABLE' => $this->aFlexform['d']['table'], 'LINK' => (t3lib_div::getIndpEnv('TYPO3_SITE_URL').$this->pi_getPageLink($GLOBALS['TSFE']->id)), 'PID' =>
				$GLOBALS['TSFE']->id, 'NOW' => date($this->aFlexform['a']['format']));
			$sSubject = $this->cObj->substituteMarkerArray($this->pi_getLL('mail.'.$_sType.'.subject'), $aMarker, '###|###');
			$aBody = explode('###BR###', $this->cObj->substituteMarkerArray($this->pi_getLL('mail.'.$_sType.'.body'), $aMarker, '###|###'));
			for($i = 0; $i < count($aBody); $i++) $aBody[$i] = wordwrap($aBody[$i], 70, $this->sLinebreak);
			$aHeader = array('From: '.$this->aFlexform['g']['mail'].' <'.$this->aFlexform['g']['mail'].'>');
			t3lib_div::plainMailEncoded($this->aFlexform['g']['mail'], $sSubject, implode($this->sLinebreak, $aBody), implode($this->sLinebreak, $aHeader), 'base64', 'utf-8');
		}
	}
	
	function tstamp($_tstamp) {
		return date($this->aFlexform['a']['format'], $_tstamp);
	}
	
	function getForm(&$_oXajaxResponse, $_sType, $_aData = array()) {
		$mId = $this->getPk($_aData);
		switch($_sType) {
			case 'edit':
				$sId = $this->encryptId($mId);
				$sIdSec = 0;
				$sNamePrefix = $this->getName('edit', $sId, '');
				break;
			case 'duplicate':
				$sId = $this->encryptId($mId);
				$sIdSec = rand(1, 32767);
				$sNamePrefix = $this->getName('add', $sIdSec).'-';
				break;
			case 'add':
				$sId = rand(1, 32767);
				$sIdSec = 0;
				$sNamePrefix = $this->getName('add', $sId).'-';
				break;
		}
		$aAfter = $aElems = array();
		if($this->aFlexform['o']['editmode'] == 'row') {
			$aJsCol = array();
			$aFocus = array(100, '');
			if($this->aFlexform['g']['multiple'] == 1 || $this->aFlexform['g']['csv'] == 'both' || $this->aFlexform['g']['csv'] == 'part') {
				$aJsCol[] = addslashes($this->getEmptyCell());
				$nPlus = 1;
			} else $nPlus = 0;
			foreach($this->aDb as $id => $col) if($col['show'] == 1) {
				$nPos = $this->aFlexform['d']['fields']['c:'.$col['name']] + $nPlus;
				$aElems[$nPos] = $id;
				if(($this->aFlexform['a']['restrict'] !== false && in_array($col['name'], $this->aFlexform['a']['restrict'])) ||
					$this->aFlexform['a']['restrict'] === false || $_sType != 'edit') {
					//$aJsCol[$nPos] = addslashes($this->getFormField($aAfter, ($sNamePrefix.$col['name']), $id, (isset($_aData[$col['name']]) ? $_aData[$col['name']] : ''), $col['length']));
					$aJsCol[$nPos] = $this->getFormField($aAfter, ($sNamePrefix.$col['name']), $id, (isset($_aData[$col['name']]) ? str_replace('\'', '\\\\\'', $_aData[$col['name']]) : ''), $col['length']);
					if($nPos < $aFocus[0]) $aFocus = array($nPos, ($sNamePrefix.$col['name']));
				} else {
					$sColName = (($col['type'] == 'foreign') ? ($this->aForeign[$col['name']]['table'].'-'.$this->aForeign[$col['name']]['show']) : $col['name']);
					$aJsCol[$nPos] = nl2br($this->prepareOutput($_aData[$sColName], $sColName));
					if($aJsCol[$nPos] == '') $aJsCol[$nPos] = $this->getEmptyCell();
				}
			}
			if(count($this->aFlexform['a']['links']) > 0) foreach($this->aFlexform['a']['links'] as $sName => $aConf) {
				if(!isset($this->aFlexform['d']['fields']['l:'.$sName])) continue;
				$aJsCol[($nPlus + $this->aFlexform['d']['fields']['l:'.$sName])] = addslashes($this->getEmptyCell());
			}
			$sSavePart = $this->getSavePart($_sType, $sId, $sIdSec);
			if($this->aFlexform['g']['del'] == 1) $aJsCol[] = addslashes($sSavePart);
			else {
				$sValue = end($aJsCol).'&nbsp;'.$sSavePart;
				$aJsCol[key($aJsCol)] = addslashes($sValue);
			}
			ksort($aJsCol);
			$sContent = 'new Array(\''.str_replace(chr(13), '', str_replace(chr(10), '', implode('\', \'', $aJsCol))).'\')';
			if($_sType == 'edit') $_oXajaxResponse->script('tx_mhomsqlio_replaceRow(\''.$this->sContElem.'\', \''.$this->getName('row', $sId).'\', '.$sContent.');');
			else {
				$_oXajaxResponse->script('tx_mhomsqlio_insertRow(\''.$this->sContElem.'\', 1, \''.$sId.'\', \'\', '.$sContent.');');
				if($aFocus[1] != '') $_oXajaxResponse->script('tx_mhomsqlio_setFocus(\''.$aFocus[1].'\');');
			}
		} else {
			$tmpl_pk = (($this->aFlexform['o']['pk'] == 1) ? $this->cObj->substituteMarkerArray($this->getTmpl('pk'), array('PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey)), '###|###') : '');
			$oTable = t3lib_div::makeInstance('mh_table');
			$aTable = array();
			foreach($this->aDb as $id => $col) if($col['show'] == 1) {
				$nPos = $this->aFlexform['d']['fields']['c:'.$col['name']];
				$aElems[$nPos] = $id;
				if($this->aFlexform['o']['pk'] == 1 && $col['pk'] == 1) $sPk = $tmpl_pk;
				else $sPk = '';
				if(($this->aFlexform['a']['restrict'] !== false && in_array($col['name'], $this->aFlexform['a']['restrict'])) ||
					$this->aFlexform['a']['restrict'] === false || $_sType != 'edit') {
					$sFormField = $this->getFormField($aAfter, ($sNamePrefix.$col['name']), $id, (isset($_aData[$col['name']]) ? $_aData[$col['name']] : ''), $col['length']);
				} else {
					$sColName = (($col['type'] == 'foreign') ? ($this->aForeign[$col['name']]['table'].'-'.$this->aForeign[$col['name']]['show']) : $col['name']);
					$sFormField = nl2br($this->prepareOutput($_aData[$sColName], $sColName));
					if($sFormField == '') $sFormField = $this->getEmptyCell();
				}
				$aTable[$nPos] = array($sPk.$this->prepareOutput($col['title']), $sFormField);
			}
			ksort($aTable);
			foreach($aTable as $aLine) $oTable->addLine($aLine);
			$oTable->addLine(array('', $this->getSavePart($_sType, ((count($_aData) > 0) ? $sId : ''), $sIdSec)));
			$_oXajaxResponse->assign($this->sDiv, 'innerHTML', $oTable->getTable());
		}
		//afterwards stuff (e.g. calendar and rte setup)
		for($i = 0; $i < count($aAfter); $i++) $_oXajaxResponse->script($aAfter[$i]);
		return $aElems;
	}
	
	function getSavePart($_sAction, $_sId, $_sIdSec = 0) {
		return $this->cObj->substituteMarkerArray($this->getTmpl('list_element_save'), array('PATH-EXT' => t3lib_extMgm::siteRelPath($this->extKey), 'ALT' =>$this->pi_getLL('label.'.$_sAction), 'ABORT' 
			=> $GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1Abort(\''.(($_sAction == 'edit') ? 'edit' : 'add').'\', \''.$_sId.'\');', 'SUBMIT' => 
			$GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1Submit(xajax.getFormValues(\''.$this->sForm.'\'), \''.$_sAction.'\''.(($_sId != '') ? (', \''.$_sId.'\''.
			(($_sIdSec != 0) ? (', \''.$_sIdSec.'\'') : '')) : '').');'), '###|###');
	}
	
	function showMsg(&$_oXajaxResponse, $_sLabel, $_nTimeOut = 2500) {
		$_oXajaxResponse->assign('tx_mhomsqlio_msg-text', 'innerHTML', $this->pi_getLL($_sLabel));
		$_oXajaxResponse->script('tx_mhomsqlio_fw(\'tx_mhomsqlio_msg\', \'style.left\', \'0px\', 0);');
		$_oXajaxResponse->script('tx_mhomsqlio_fw(\'tx_mhomsqlio_msg\', \'style.top\', \'0px\', 0);');
		$_oXajaxResponse->script('tx_mhomsqlio_display(\'tx_mhomsqlio_msg\', 1);');
		if($_nTimeOut > 0) $_oXajaxResponse->script('window.setTimeout(\'tx_mhomsqlio_block(\\\'tx_mhomsqlio_msg\\\')\', '.$_nTimeOut.')');
	}
	
	function writeCsv(&$_oXajaxResponse, $_sSql, $_sDelimiter, $_sQuote) {
		if($oResult = $this->oDb->execute($_sSql)) {
			$aCsv = array();
			while($aRow = $this->oDb->getAssoc($oResult)) {
				foreach($aRow as $sField => $sValue) {
					$sFieldname = $this->findDbParam('title', $sField, 'name');
					$aRow[$sField] = $this->prepareOutput($sValue, $sFieldname, true, true);
				}
				if(count($aCsv) <= 0) $aCsv[] = t3lib_div::csvValues(array_keys($aRow), $_sDelimiter, $_sQuote);
				$aCsv[] = t3lib_div::csvValues($aRow, $_sDelimiter, $_sQuote);
			}
			$sFilename = t3lib_div::tempnam(date('YmdHi').'-').'.csv';
			t3lib_div::writeFile($sFilename, implode($this->sLinebreak, $aCsv));
			$_oXajaxResponse->script('window.location.href = \''.t3lib_extMgm::siteRelPath('mh_omsqlio').'pi1/tx_mhomsqlio_csv.php?table='.
				substr($this->aFlexform['d']['table'], 1, strlen($this->aFlexform['d']['table']) - 2).'&file='.$sFilename.'\';');
		}
	}
	
	function getEmptyCell() {
		return '&nbsp;';
	}
	
	function abort(&$_oXajaxResponse, $_sType = 'add', $_sId = '', $_sOrder = '', $_sMsg = '') {
		switch($_sType) {
			case 'add':
				if($this->aFlexform['o']['editmode'] == 'row') $_oXajaxResponse->script('tx_mhomsqlio_removeRow(\''.$this->sContElem.'\', \''.$_sId.'\');');
				else {
					$_oXajaxResponse->assign($this->sForm, 'innerHTML', $this->showFull($_sOrder, false));
					$_oXajaxResponse->script('Table.auto();');
				}
				break;
			case 'edit':
			case 'save':
				if($this->aFlexform['o']['editmode'] == 'row') $this->getSingleLine($_sId, $_oXajaxResponse);
				else $_oXajaxResponse->script($GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1Filter(\'\'); Table.auto();');
				break;
			case 'added':
			case 'del-multiple':
				$_oXajaxResponse->script($GLOBALS['TSFE']->TYPO3_CONF_VARS['mh_xajax']->getPre($this->prefixId).'tx_mhomsqlio_pi1Filter(\'\'); Table.auto();');
				break;
			case 'del':
				$_oXajaxResponse->script('tx_mhomsqlio_removeRow(\''.$this->sContElem.'\', \''.$this->getName('row', $_sId).'\');');
				break;
			case 'all':
				$_oXajaxResponse->assign($this->sForm, 'innerHTML', $this->showFull('', false));
				$_oXajaxResponse->script('tx_mhomsqlio_cleanSearch(\''.$this->sContElem.'\');');
				$_oXajaxResponse->script('Table.auto();');
				$_oXajaxResponse->script('Table.filter(document.getElementById(\''.$this->getName('table').'\'));');
				break;
		}
		//$_oXajaxResponse->script('tx_mhomsqlio_goto(\'reload\');');
		if($_sMsg != '') $this->showMsg($_oXajaxResponse, $_sMsg);
		if($this->aFlexform['o']['editmode'] == 'row' && $this->aFlexform['o']['condform'] === false)
			$_oXajaxResponse->script('Table.stripe(document.getElementById(\''.$this->getName('table').'\'), \''.$this->aFlexform['o']['class-alternate'].'\');');
	}
	
	function escapedTrimExplode($_sSplit, $_sText, $_nLimit = -1, $_bCutEmpty = false) {
		$aTemp = preg_split('/[^\\\\]'.$_sSplit.'/', $_sText, $_nLimit, PREG_SPLIT_OFFSET_CAPTURE);
		for($i = 0; $i < count($aTemp); $i++) {
			if($aTemp[$i][1] > (strlen($aTemp[$i-1][0]) + 1)) $aTemp[$i-1] .= $_sText{$aTemp[$i][1]-2};
			$aTemp[$i] = trim(str_replace('\\'.$_sSplit, $_sSplit, $aTemp[$i][0]));
			if($_bCutEmpty && $aTemp[$i] == '') unset($aTemp[$i]);
		}
		return $aTemp;
	}
	
	function fetchColor($_aData) {
		$sColor = '#FFF';
		$aMarker = array();
		foreach($_aData as $sKey => $sValue) $aMarker['$'.$sKey] = '$_aData[\''.$sKey.'\']';
		for($i = 0; $i < count($this->aFlexform['o']['condform']); $i++) {
			if(count($this->aFlexform['o']['condform'][$i]) == 2) {
				if(eval('return ('.$this->cObj->substituteMarkerArray($this->aFlexform['o']['condform'][$i][0], $aMarker, '|').') ? true : false;') === true) {
					$sColor = $this->cObj->substituteMarkerArray($this->aFlexform['o']['condform'][$i][1], $_aData, '###|###');
					break;
				}
			} else {	//this is the absolute else part
				$sColor = $this->cObj->substituteMarkerArray($this->aFlexform['o']['condform'][$i][0], $_aData, '###|###');
				break;
			}
		}
		return $sColor;
	}
	
	function _showEdit($_sId, $_nCellIndex) {
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		if($this->aFlexform['g']['edit'] != 1) {
			$oXajaxResponse->script('alert(\''.addslashes($this->pi_getLL('error.perm')).'\');');
			return $oXajaxResponse;
		}
		$aData = $this->oDb->getOneRow('SELECT * FROM '.$this->aFlexform['d']['table'].' WHERE '.$this->getWhere('pk', $this->decryptId($_sId)));
		$aElems = $this->getForm($oXajaxResponse, 'edit', $aData);
		if($this->aFlexform['o']['editmode'] == 'row') {
			$oXajaxResponse->script('tx_mhomsqlio_setFocus(\''.$this->getName('edit', $_sId, $this->aDb[$aElems[$_nCellIndex]]['name']).'\');');
			if($this->aFlexform['o']['condform'] === false)
				$oXajaxResponse->script('Table.stripe(document.getElementById(\''.$this->getName('table').'\'), \''.$this->aFlexform['o']['class-alternate'].'\');');
			else $oXajaxResponse->script('tx_mhomsqlio_color(\''.$this->getName('row', $_sId).'\', \''.$this->fetchColor($aData).'\');');
		}
		return $oXajaxResponse;
	}
	
	function _abort($_sType = 'add', $_sId = '', $_sOrder = '', $_sMsg = '') {
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		$this->abort($oXajaxResponse, $_sType, $_sId, $_sOrder, $_sMsg);
		return $oXajaxResponse;
	}
	
	function _showAdd($_sIdCopy = '') {
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		if($this->aFlexform['g']['add'] != 1) {
			$oXajaxResponse->script('alert(\''.addslashes($this->pi_getLL('error.perm')).'\');');
			return $oXajaxResponse;
		}
		if($_sIdCopy == '') $this->getForm($oXajaxResponse, 'add');
		else {
			$aData = $this->oDb->getOneRow('SELECT * FROM '.$this->aFlexform['d']['table'].' WHERE '.$this->getWhere('pk', $this->decryptId($_sIdCopy)));
			$this->getForm($oXajaxResponse, 'duplicate', $aData);
		}
		if($this->aFlexform['o']['editmode'] == 'row' && $this->aFlexform['o']['condform'] === false)
			$oXajaxResponse->script('Table.stripe(document.getElementById(\''.$this->getName('table').'\'), \''.$this->aFlexform['o']['class-alternate'].'\');');
		return $oXajaxResponse;
	}
	
	function _del($_id) {
		$_id = $this->decryptId($_id);
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		if($this->aFlexform['g']['del'] != 1) {
			$oXajaxResponse->script('alert(\''.addslashes($this->pi_getLL('error.perm')).'\');');
			return $oXajaxResponse;
		}
		if(is_array($this->aFlexform['a']['changedel'])) {
			$sql = 'UPDATE '.$this->aFlexform['d']['table'].' SET '.$this->aFlexform['a']['changedel']['col'].' = \''.$this->aFlexform['a']['changedel']['del'].'\' WHERE '.$this->getWhere('pk', $_id);
		} else $sql = 'DELETE FROM '.$this->aFlexform['d']['table'].' WHERE '.$this->getWhere('pk', $_id);
		if($this->oDb->execute($sql)) {
			$this->mail('del');
			$this->abort($oXajaxResponse, 'del', $_id, '', 'msg.deleted');
		} else $oXajaxResponse->script('alert(\''.$this->pi_getLL('error.del').'\');');
		return $oXajaxResponse;
	}
	
	function _submit($_aFrmdata, $_sAction, $_sId = 0, $_sIdSecond = 0) {
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		if(($this->aFlexform['g']['edit'] + $this->aFlexform['g']['add']) <= 0) {
			$oXajaxResponse->script('alert(\''.addslashes($this->pi_getLL('error.perm')).'\');');
			return $oXajaxResponse;
		}
		switch($_sAction) {
			case 'duplicate':
				$aInsert = $this->oDb->getOneRowAssoc('SELECT * FROM '.$this->aFlexform['d']['table'].' WHERE '.$this->getWhere('pk', $this->decryptId($_sId)));
				if($this->aFlexform['a']['changedate'] != '')  unset($aInsert[$this->aFlexform['a']['changedate']]);
				$sPrefix = $this->getName('add', $_sIdSecond).'-';
				$sMsg = 'added';
				break;
			case 'add':
				$sPrefix = $this->getName('add', $_sId).'-';
				$aInsert = array();
				$sMsg = 'added';
				break;
			case 'edit':
				$sPrefix = $this->getName('edit', $_sId, '');
				$sMsg = 'saved';
				$aInsert = $this->oDb->getOneRowAssoc('SELECT * FROM '.$this->aFlexform['d']['table'].' WHERE '.$this->getWhere('pk', $this->decryptId($_sId)));
				break;
		}
		foreach($this->aDb as $aCol) if($aCol['show'] == 1) $this->prepareInput($aInsert, $aCol['name'], $_aFrmdata[$sPrefix.$aCol['name']]);
		if($this->aFlexform['a']['changedate'] != '')  $this->prepareInput($aInsert, $this->aFlexform['a']['changedate'], mktime(), false);
		if($this->aFlexform['d']['login-uid'] != '') $this->prepareInput($aInsert, $this->aFlexform['d']['login-uid'], $GLOBALS['TSFE']->fe_user->user['uid']);
		if($this->aFlexform['d']['login-username'] != '') $this->prepareInput($aInsert, $this->aFlexform['d']['login-username'], $GLOBALS['TSFE']->fe_user->user['username']);
		if($this->aFlexform['a']['changedel']['col'] != '') $this->prepareInput($aInsert, $this->aFlexform['a']['changedel']['col'], $this->aFlexform['a']['changedel']['undel'], false);
		if($_sAction != 'edit') {
			$sSql = 'INSERT INTO '.$this->aFlexform['d']['table'].' (';
			$aValues = array();
			foreach($aInsert as $sKey => $sValue) {
				if($_sAction == 'duplicate' && $this->findDbParam('name', $sKey, 'pk', 2) == 1) continue;
				$sSql .= $sKey.', ';
				$aValues[] = '\''.mysql_real_escape_string(stripslashes($sValue)).'\'';
			}
			$sSql = substr($sSql, 0, (strlen($sSql) - 2)).') VALUES ('.implode(', ', $aValues).')';
		} else {
			$sSql = 'UPDATE '.$this->aFlexform['d']['table'].' SET ';
			foreach($aInsert as $sKey => $sValue) if(($this->aFlexform['a']['restrict'] !== false && 
				in_array($sKey, $this->aFlexform['a']['restrict'])) || $this->aFlexform['a']['restrict'] === false) { 
				$sSql .= $sKey.' = \''.mysql_real_escape_string(stripslashes($sValue)).'\', ';
			}
			$sSql = substr($sSql, 0, (strlen($sSql) - 2)).' WHERE '.$this->getWhere('pk', $this->decryptId($_sId));
		}
		if($this->oDb->execute($sSql)) {
			$this->mail($sMsg);
			$this->abort($oXajaxResponse, (($_sAction == 'add' || $_sAction == 'duplicate') ? 'added' : $_sAction), (($_sIdSecond != 0) ? $_sIdSecond : $_sId), '', ('msg.'.$sMsg));
		} else $this->showMsg($oXajaxResponse, 'error.'.$sMsg, 3500);
		return $oXajaxResponse;
	}

	function _multipleDel($_ids) {
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		if($this->aFlexform['g']['multiple'] != 1) {
			$oXajaxResponse->script('alert(\''.addslashes($this->pi_getLL('error.perm')).'\');');
			return $oXajaxResponse;
		}
		for($j = 0; $j < count($_ids); $j++) $this->_del($_ids[$j]);
		$this->abort($oXajaxResponse, 'del-multiple');
		return $oXajaxResponse;
	}
	
	function _multipleEdit($_ids) {
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		if($this->aFlexform['g']['multiple'] != 1) {
			$oXajaxResponse->script('alert(\''.addslashes($this->pi_getLL('error.perm')).'\');');
			return $oXajaxResponse;
		}
		$sRememberMode = $this->aFlexform['o']['editmode'];
		$this->aFlexform['o']['editmode'] = 'row';
		for($j = 0; $j < count($_ids); $j++) $this->getForm($oXajaxResponse, 'edit', $this->oDb->getOneRow('SELECT * FROM '.$this->aFlexform['d']['table'].
			' WHERE '.$this->getWhere('pk', $this->decryptId($_ids[$j]))));
		$this->aFlexform['o']['editmode'] = $sRememberMode;
		return $oXajaxResponse;
	}

	function _filter($_q, $_order = '') {
		//check if it's a clear filter request
		$_q = trim(addslashes($_q));
		if($_q === '' || $_q == $this->pi_getLL('js.search')) {
			$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
			$oXajaxResponse->assign($this->sDiv, 'innerHTML', $this->showList($_order));
			$oXajaxResponse->script('Table.auto(this);');
			$oXajaxResponse->script('Table.filter(document.getElementById(\''.$this->getName('table').'\'), null);');
			return $oXajaxResponse;
		}
		
		$qumarks = substr_count($_q, '"');
		$qs = array();
		if($qumarks >= 2) {
			$qstring = $_q;
			for($i = 1; $i <= $qumarks; $i++) {
				list($qrest, $qstring) = explode('\\"', trim($qstring), 2);
				$qrest = trim($qrest);
				if($i % 2 == 1) {
					if($qrest != '') {
						$qrests = explode(' ', $qrest);
						foreach($qrests as $qrest) $qs[] = array($qrest, '');
					}
				} else {
					if($qrest != '') $qs[] = array($qrest, '"');
				}
			}
			$qstring = trim($qstring);
			if($qstring != '') $qs[] = array($qstring, '');
		} else {
			$qrests = explode(' ', $_q);
			foreach($qrests as $qrest) if(strlen($qrest) > 0) $qs[] = array($qrest, '');
		}
		
		$sstrings = array();
		foreach($qs as $q) {
			$qgroup = array();
			foreach($this->aDb as $col) {
				if($this->aFlexform['d']['search_all'] == 1 || $col['show'] == 1) {
					if(isset($this->aForeign[$col['name']])) {
						$col['name'] = '(SELECT '.(($this->aForeign[$col['name']]['show']{0} == '#') ? substr($this->aForeign[$col['name']]['show'], 1) : 
							$this->aForeign[$col['name']]['show']).' FROM '.$this->aForeign[$col['name']]['table'].' WHERE '.$this->aForeign[$col['name']]['table'].'.'.
							$this->aForeign[$col['name']]['pk'].' = '.$this->aFlexform['d']['table'].'.'.$this->aForeign[$col['name']]['fk'].' LIMIT 1)';
					} else $col['name'] = $this->aFlexform['d']['table'].'.'.$col['name'];
					if($q[1] == '"') $qgroup[] = $col['name'].' LIKE \'%'.$q[0].'%\' ';
					else $qgroup[] =  $col['name'].' LIKE \'%'.preg_replace('/ +/', '%', $q[0]).'%\' ';
				}
			}
			$sstrings[] = '('.implode(' OR ', $qgroup).')';
		}
		
		$where = '('.implode(' AND ', $sstrings).')';
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		$oXajaxResponse->assign($this->sDiv, 'innerHTML', $this->showList($_order, array('sql' => $where, 'sword' => $_q)));
		$oXajaxResponse->script('Table.auto(this);');
		$oXajaxResponse->script('tx_mhomsqlio_fw(\'tx_mhomsqlio_spinner-'.$this->sContElem.'\', \'style.display\', \'none\', 0)');
		return $oXajaxResponse;
	}
	
	function _download($_ids = array(), $_sDelimiter = ';', $_sQuote = '') {
		$oXajaxResponse = t3lib_div::makeInstance('xajaxResponse');
		if($this->aFlexform['g']['csv'] == 'none') {
			$oXajaxResponse->script('alert(\''.addslashes($this->pi_getLL('error.perm')).'\');');
			return $oXajaxResponse;
		}
		if(!is_array($_ids) && $_ids == -1 && ($this->aFlexform['g']['csv'] == 'all' || $this->aFlexform['g']['csv'] == 'both')) {
			$this->writeCsv($oXajaxResponse, $this->createSql('', array(), true), $_sDelimiter, $_sQuote);
		} elseif((count($_ids) <= 0 && $this->aFlexform['g']['csv'] == 'part') || $this->aFlexform['g']['csv'] == 'none') {
			$this->showMsg($oXajaxResponse, 'error.perm');
		} else {
			$aIds = array();
			for($i = 0; $i < count($_ids); $i++) $aIds[] = '('.$this->getWhere('pk', $this->decryptId($_ids[$i])).')';
			$this->writeCsv($oXajaxResponse, $this->createSql('', array('('.implode(' OR ', $aIds).')'), true), $_sDelimiter, $_sQuote);
		}
		return $oXajaxResponse;
	}
}


if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/mh_omsqlio/pi1/class.tx_mhomsqlio_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/mh_omsqlio/pi1/class.tx_mhomsqlio_pi1.php"]);
}

?>