<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 Mario Haim (mario@bramble-it.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'RTE Handler' for the 'mh_omsqlio' extension.
 *
 * @author	Mario Haim <mario@bramble-it.com>
 */


include_once(t3lib_extMgm::extPath('rtehtmlarea').'pi2/class.tx_rtehtmlarea_pi2.php');

class tx_mhomsqlio_rte {

	var $oRte;
	var $docLarge = 0;
	var $RTEcounter = 0;
	var $formName;
	var $additionalJS_initial = '';// Initial JavaScript to be printed before the form (should be in head, but cannot due to IE6 timing bug)
	var $additionalJS_pre = array();// Additional JavaScript to be printed before the form (works in Mozilla/Firefox when included in head, but not in IE6)
	var $additionalJS_post = array();// Additional JavaScript to be printed after the form
	var $additionalJS_submit = array();// Additional JavaScript to be executed on submit
	var $PA = array('itemFormElName' => '', 'itemFormElValue' => '');
	//var $specConf = array('rte_transform' => array('parameters' => array('mode' => 'ts_css')));
	var $specConf = array();
	var $thisConfig = array();
	var $RTEtypeVal = 'text';
	var $thePidValue;

	function tx_mhomsqlio_rte() {
		$this->oRte = t3lib_div::makeInstance('tx_rtehtmlarea_pi2');
	}
	
	function draw($_sValue, $_sForm, $_sName) {
		if(!$this->oRte) $this->oRte = t3lib_div::makeInstance('tx_rtehtmlarea_pi2');
		if($this->oRte->isAvailable()) {
			$this->RTEcounter++;
			$this->formName = $_sForm;
			$this->PA['itemFormElName'] = $_sName;
			$this->PA['itemFormElValue'] = $_sValue;
			$this->thePidValue = $GLOBALS['TSFE']->id;
			$RTEItem = $this->oRte->drawRTE($this, 'my-table-name', $_sName, array(), $this->PA, $this->specConf, $this->thisConfig, $this->RTEtypeVal, '', $this->thePidValue);
			
			return array(
				'JS-PRE' => $this->int_prepareJs($this->additionalJS_initial.chr(10).implode(chr(10), $this->additionalJS_pre).chr(10)),
				'JS-POST' => $this->int_prepareJs(implode(chr(10), $this->additionalJS_post).chr(10)),
				'ONSUBMIT' => implode(';', $this->additionalJS_submit),
				'RTE' => $RTEItem,
				'JS-HEAD' => $TSFE->additionalHeaderData['htmlArea']
			);
		} return false;
	}
	
	function prepare($_sName, $_sValue) {
		if($this->oRte->isAvailable()) {
			$pageTSConfig = $GLOBALS['TSFE']->getPagesTSconfig();
			$RTEsetup = $pageTSConfig['RTE.'];
			$this->thisConfig = $RTEsetup['default.'];
			$this->thisConfig = $this->thisConfig['FE.'];
			return $this->oRte->transformContent('db', $_sValue, 'my-table-name', $_sName, array(), $this->specConf, $this->thisConfig, '', $this->thePidValue);
		} else return '';
	}
	
	function int_prepareJs($_sJs) {
		$_sJs = str_replace('<script type="text/javascript">', '', str_replace('</script>', '', $_sJs));
		$_sJs = str_replace('/*<![CDATA[*/', '', str_replace('/*]]>*/', '', $_sJs));
		return preg_replace_callback('#<script type="text/javascript" src=".+">#', array($this, 'int_callback_readFile'), $_sJs);
	}
	
	function int_callback_readFile($_aString) {
		list(, $sFile) = explode(' src="', $_aString[0]);
		list($sFile) = explode('"', $sFile);
		return file_get_contents(PATH_site.$sFile);
	}
}

?>